﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    public abstract class BaseView
    {// die basisklasse für alle views
        public GraphicsManager Graphics;
        public InputManager Input;
        public SoundManager Sound;
        public ViewManager Views;
        public GameData Gamedata;
        protected Vector2 tempvect;
        public List<Control> Controls;

        public BaseView(GraphicsManager graphicsman, InputManager inputman, SoundManager soundman, ViewManager viewman, GameData gamedat)
        {// konstruktor
            tempvect = new Vector2();
            Controls = new List<Control>();
            Graphics = graphicsman;
            Input = inputman;
            Sound = soundman;
            Views = viewman;
            Gamedata = gamedat;
        }
        public abstract void Update();  // führt updates durch (physik, gui)
        public abstract void Draw();  // rendert die view
    }
}
