﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlanetaryDomination
{
    public class BattleAI
    {
        public Sector BattleSector;
        BattleSector tempsec;
        public int DefenderIndex, AttackerIndex, ActDefender, ActAttacker, BestTargetIndex, BestSectorIndex, DestroyedAttackers, DestroyedDefenders, InitialAttackers, InitialDefenders;
        public GameData Gamedat;
        float BestTargetScore, ActTargetScore;
        public List<Unit> Attackers, Defenders;
        BattleManager BattleMan;
        int[] DefenderFrontSectors;
        int[] DefenderBackSectors;
        int[] AttackerFrontSectors;
        int[] AttackerBackSectors;
        bool DefenderWon;

        public BattleAI(Sector sect, GameData game, BattleManager bm)
        {
            BattleSector = sect;
            BattleMan = bm;
            Gamedat = game;
            ActDefender = ActAttacker = DestroyedAttackers = DestroyedDefenders = 0;
            Defenders = new List<Unit>();
            Attackers = new List<Unit>();
            DefenderFrontSectors = new int[] {3,9,15,4,10,16,5,11,17};
            DefenderBackSectors = new int[] {5,11,17,4,10,16,3,9,15};
            AttackerFrontSectors = new int[] {2,8,14,1,7,13,0,6,12};
            AttackerBackSectors = new int[] {0,6,12,1,7,13,2,8,14};
            DefenderWon = false;

            if (BattleSector.Owner != 8)
            {// sektor hat besitzer also alle eigenen einheiten als defender
                for (int i = 0; i < BattleSector.Units.Count; i++)
                {
                    if (BattleSector.Owner == BattleSector.Units[i].Owner)
                        Defenders.Add(BattleSector.Units[i]);
                    else
                    {
                        if ((Attackers.Count == 0) || ((Attackers.Count > 0) && (Attackers[0].Owner == BattleSector.Units[i].Owner)))
                        {// es gibt noch keinen angreifer also den ersten nehmen oder es wurde schon ein angreifer hinzugefügt also jetzt nur noch einheiten desselben nehmen
                            Attackers.Add(BattleSector.Units[i]);
                        }
                    }
                }
                DefenderIndex = sect.Owner;// der sector gehört einem spieler
            }
            else
            {
                for (int i = 0; i < sect.Units.Count; i++)
                {// alle einheiten durchgehen
                    if (sect.Units[i].ETA == 0)
                    {// einheit ist schon da
                        if (sect.Units[0].Owner == sect.Units[i].Owner)
                        {// einheit verteidigt
                            Defenders.Add(sect.Units[i]);
                        }
                        else
                        {// einheit greift an
                            Attackers.Add(sect.Units[i]);
                        }
                    }
                }
                DefenderIndex = Defenders[0].Owner;// es sind nur einheiten der spieler dort stationiert (gehört niemandem)
            }
            AttackerIndex = Attackers[0].Owner;
            InitialAttackers = Attackers.Count;
            InitialDefenders = Defenders.Count;
            AutoPlaceAttackers();
            AutoPlaceDefenders();
        }
        public void Autofight()
        {
            while (!BattleOver())
            {// einen nach dem anderen ziehen lassen bis eine seite zerstört
                AutoMoveDefender();
                AutoMoveAttacker();
            }
        }
        public void Playerfight()
        {// setzt den modus für den spieler seine einheiten zu setzen
            Autofight();
        }
        public void AutoPlaceAttackers()
        {// platziert die angreifer automatisch (linke seite)
            for (int i = 0; i < Attackers.Count; i++)
            {
                if ((0 == Attackers[i].Type) || (1 == Attackers[i].Type) || (6 == Attackers[i].Type) || (7 == Attackers[i].Type))
                {// prospektor, basemodule, artillery, building hinten platzieren
                    tempsec = GetFreeAttackerBack();
                }
                else
                {
                    tempsec = GetFreeAttackerFront();
                }
                tempsec.Unit = Attackers[i];
                Attackers[i].Battlesec = tempsec.Number;
            }
        }
        public void AutoPlaceDefenders()
        {// platziert die verteidiger automatisch (rechte seite)
            for (int i = 0; i < Defenders.Count; i++)
            {
                if ((0 == Defenders[i].Type) || (1 == Defenders[i].Type) || (6 == Defenders[i].Type) || (7 == Defenders[i].Type))
                {// prospektor, basemodule, artillery, building hinten platzieren
                    tempsec = GetFreeDefenderBack();
                }
                else
                {
                    tempsec = GetFreeDefenderFront();
                }
                tempsec.Unit = Defenders[i];
                Defenders[i].Battlesec = tempsec.Number;
            }
        }
        public bool BattleOver()
        {// prüft ob kampf vorbei ist
            if ((0 == Defenders.Count) && (Attackers.Count > 0)) //wenn attacker 0 passiert nichts, wenn defender 0 wird owner des sektors geändert und kampf beendet
            {// die verteidiger sind unterlegen also die angreifer als units setzen
                BattleSector.Owner = Attackers[0].Owner;
                DefenderWon = false;
                Attackers.Clear();
                Defenders.Clear();
                BattleMan.ClearUnits();
            }
            else if ((0 == Attackers.Count) && (Defenders.Count > 0))
            {
                DefenderWon = true;
                Attackers.Clear();
                Defenders.Clear();
                BattleMan.ClearUnits();
            }
            return ((0 == Defenders.Count) || (0 == Attackers.Count));
        }
        public void AutoMoveDefender()
        {// zieht die verteidiger
            if (0 == Defenders.Count)
                return;
            if (ActDefender >= Defenders.Count)
                ActDefender = 0;    // von vorn beginnen weil der letzte gerade zerstört wurde
            int i, j = 0, dist, bestdist = 0;
            bool targetfound = false;
            BestTargetScore = 0.0f;
            for (i = 0; i < BattleMan.Battlefield.Count; i++)
            {// alle sektoren prüfen ob sich einheit dahin bewegen kann (frei + in reichweite) wenn was dazwischen ist stört nicht
                if ((BattleMan.Battlefield[i].Unit == null) || (BattleMan.Battlefield[i].Unit == Defenders[ActDefender]))
                {// sektor ist leer dort wo die einheit schon ist
                    for (j = 0; j < Attackers.Count; j++)
                    {// für die aktuelle verteidigereinheit jedes ziel durchgehen und score berechnen
                        dist = BattleMan.GetSectorDistance(BattleMan.Battlefield[i], BattleMan.Battlefield[Defenders[ActDefender].Battlesec]);
                        if (dist <= Defenders[ActDefender].BattleMoveRange)
                        {// einheit kann sich überhaupt dahin bewegen
                            ActTargetScore = GetTargetScore(Defenders[ActDefender], Attackers[j], dist);
                            if (ActTargetScore > BestTargetScore)
                            {
                                BestTargetScore = ActTargetScore;
                                BestTargetIndex = j;
                                BestSectorIndex = i;
                                bestdist = dist;
                                targetfound = true;
                            }
                        }
                    }
                }
            }
            if (targetfound)
            {// nur wenn wirklich ein ziel gefunden wurde feuern da sonst evtl ein altes genommen wird was schon nicht mehr existiert
                BattleMan.Battlefield[Defenders[ActDefender].Battlesec].Unit = null;    // zum optimalen sector bewegen und auf optimales ziel schießen
                BattleMan.Battlefield[BestSectorIndex].Unit = Defenders[ActDefender];
                Defenders[ActDefender].Battlesec = BestSectorIndex;
                Defenders[ActDefender].AttackUnit(Attackers[BestTargetIndex], bestdist);
                if (Attackers[BestTargetIndex].Hitpoints <= 0.0f)
                {// ziel wurde zerstört also löschen und erfahrung geben
                    BattleSector.Units.Remove(Attackers[BestTargetIndex]); // einheit aus sektor entfernen
                    BattleMan.Battlefield[Attackers[BestTargetIndex].Battlesec].Unit = null;
                    Attackers.RemoveAt(BestTargetIndex);

                    ++DestroyedAttackers;
                    Defenders[ActDefender].Experience *= 1.05f;
                    if (ActAttacker == BestTargetIndex)
                    {// einheit wurde zerstört also neu setzen
                        if (++ActAttacker >= Attackers.Count)
                            ActAttacker = 0;    // von vorn beginnen
                    }
                }
            }
            if (++ActDefender >= Defenders.Count)
                ActDefender = 0;    // von vorn beginnen
        }
        public void AutoMoveAttacker()
        {// zieht die angreifer
            if (0 == Attackers.Count)
                return;
            if (ActAttacker >= Attackers.Count)
                ActAttacker = 0;    // von vorn beginnen weil der letzte gerade zerstört wurde
            int i, j = 0, dist, bestdist = 0;
            bool targetfound = false;
            BestTargetScore = 0.0f;
            for (i = 0; i < BattleMan.Battlefield.Count; i++)
            {// alle sektoren prüfen ob sich einheit dahin bewegen kann (frei + in reichweite) wenn was dazwischen ist stört nicht
                if ((BattleMan.Battlefield[i].Unit == null) || (BattleMan.Battlefield[i].Unit == Attackers[ActAttacker]))
                {
                    for (j = 0; j < Defenders.Count; j++)
                    {// für die aktuelle verteidigereinheit jedes ziel durchgehen und score berechnen
                        dist = BattleMan.GetSectorDistance(BattleMan.Battlefield[i], BattleMan.Battlefield[Attackers[ActAttacker].Battlesec]);
                        if (dist <= Attackers[ActAttacker].BattleMoveRange)
                        {// einheit kann sich überhaupt dahin bewegen
                            ActTargetScore = GetTargetScore(Attackers[ActAttacker], Defenders[j], dist);
                            if (ActTargetScore > BestTargetScore)
                            {
                                BestTargetScore = ActTargetScore;
                                BestTargetIndex = j;
                                BestSectorIndex = i;
                                bestdist = dist;
                                targetfound = true;
                            }
                        }
                    }
                }
            }
            if (targetfound)
            {// nur wenn wirklich ein ziel gefunden wurde feuern da sonst evtl ein altes genommen wird was schon nicht mehr existiert
                BattleMan.Battlefield[Attackers[ActAttacker].Battlesec].Unit = null;    // zum optimalen sector bewegen und auf optimales ziel schießen
                BattleMan.Battlefield[BestSectorIndex].Unit = Attackers[ActAttacker];
                Attackers[ActAttacker].Battlesec = BestSectorIndex;
                Attackers[ActAttacker].AttackUnit(Defenders[BestTargetIndex], bestdist);
                if (Defenders[BestTargetIndex].Hitpoints <= 0.0f)
                {// ziel wurde zerstört also löschen und erfahrung geben
                    BattleSector.Units.Remove(Defenders[BestTargetIndex]);
                    BattleMan.Battlefield[Defenders[BestTargetIndex].Battlesec].Unit = null;
                    Defenders.RemoveAt(BestTargetIndex);
                    Attackers[ActAttacker].Experience *= 1.05f;
                    ++DestroyedDefenders;
                    if (ActDefender == BestTargetIndex)
                    {// einheit wurde zerstört also neu setzen
                        if (++ActDefender >= Defenders.Count)
                            ActDefender = 0;    // von vorn beginnen
                    }
                }
            }
            if (++ActAttacker >= Attackers.Count)
                ActAttacker = 0;    // von vorn beginnen
        }
        public float GetTargetScore(Unit shooter, Unit target, int distance)
        {// berechnet wie gut es ist das ziel zu treffen (ob überhaupt)
            float score = 0.0f;
            if ((distance >= shooter.MinFireRange) && (distance <= shooter.MaxFireRange))
            {// ziel ist in reichweite also trefferchance + schaden prüfen und sehen ob die einheit dadurch ausgeschaltet werden könnte
                score = ((shooter.Attack * shooter.Experience) / (target.Defence * target.Experience)) * shooter.Damage;
                if (target.Hitpoints - score <= 0.0f)   // gute chance dass die einheit durch den schuss zerstört wird also dass bevorzugen damit sie weg ist und keine gefahr mehr ist
                    score *= 10.0f;
            }
            return score;
        }
        private BattleSector GetFreeDefenderFront()
        {// liefert den nächsten freien sektor an der verteidigerfront
            int i;
            for(i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[DefenderFrontSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[DefenderFrontSectors[i]];
        }
        private BattleSector GetFreeDefenderBack()
        {// liefert den nächsten freien sektor im verteidiger hinterland
            int i;
            for (i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[DefenderBackSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[DefenderBackSectors[i]];
        }
        private BattleSector GetFreeAttackerFront()
        {// liefert den nächsten freien sektor an der angreiferfront
            int i;
            for (i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[AttackerFrontSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[AttackerFrontSectors[i]];
        }
        private BattleSector GetFreeAttackerBack()
        {// liefert den nächsten freien sektor im angreifer hinterland
            int i;
            for (i = 0; i < 9; i++)
            {
                if (null == BattleMan.Battlefield[AttackerBackSectors[i]].Unit)
                    break;
            }
            return BattleMan.Battlefield[AttackerBackSectors[i]];
        }
        public bool PlayerInvolved()
        {// prüft ob der spieler am kampf teilnimmt oder nicht
            if ((Gamedat.HumanPlayer == Attackers[0].Owner) || ((Defenders.Count > 0) && (Defenders[0].Owner == Gamedat.HumanPlayer)) || (BattleSector.Owner == Gamedat.HumanPlayer))
            {// spieler ist betroffen
                return true;
            }
            return false;
        }
    }
}
