﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace PlanetaryDomination
{
    public class BattleView : BaseView
    {
        public BattleAI Battle;
        public BattleManager BattleMan;
        public String SituationString;

        public BattleView(GraphicsManager graphicsman, InputManager inputman, SoundManager soundman, ViewManager viewman, GameData gamedat) : base(graphicsman, inputman, soundman, viewman, gamedat)
        {// konstruktor
            Controls.Add(new Button(950, 650, 280, 30, "Attack [a]", Color.Azure, 4, Graphics, Input, Sound));   // #0
            ((Button)(Controls[0])).ButtFunc = Attackfunc;
            ((Button)(Controls[0])).Shortkey = Keys.A;
            ((Button)(Controls[0])).Active = false;
            Controls.Add(new Button(950, 690, 280, 30, "Move [m]", Color.Azure, 4, Graphics, Input, Sound));   // #1
            ((Button)(Controls[1])).ButtFunc = Movefunc;
            ((Button)(Controls[1])).Shortkey = Keys.M;
            ((Button)(Controls[1])).Active = false; 
            Controls.Add(new Button(950, 730, 280, 30, "Skip [s]", Color.Azure, 4, Graphics, Input, Sound));   // #2
            ((Button)(Controls[2])).ButtFunc = Skipfunc;
            ((Button)(Controls[2])).Shortkey = Keys.S;
            ((Button)(Controls[2])).Active = false;
            Controls.Add(new Button(950, 770, 280, 30, "Give Up [g]", Color.Azure, 4, Graphics, Input, Sound));   // #3
            ((Button)(Controls[3])).ButtFunc = GiveUpfunc;
            ((Button)(Controls[3])).Shortkey = Keys.G;
            ((Button)(Controls[3])).Active = false;
            Controls.Add(new Button(950, 810, 280, 30, "Autofight [f]", Color.Azure, 4, Graphics, Input, Sound));   // #4
            ((Button)(Controls[4])).ButtFunc = AutofightFunc;
            ((Button)(Controls[4])).Shortkey = Keys.F;
            ((Button)(Controls[4])).Active = false;
            Controls.Add(new Button(950, 850, 280, 30, "Back [Enter]", Color.Azure, 4, Graphics, Input, Sound));   // #5
            ((Button)(Controls[5])).ButtFunc = NextTurnFunc;
            ((Button)(Controls[5])).Shortkey = Keys.Enter;
            ((Button)(Controls[5])).Active = false;
        }
        override public void Draw()
        {// rendert alles
            BattleMan.Draw();
            tempvect.X = 10.0f;
            tempvect.Y = 650.0f;
            Graphics.DrawText(SituationString, tempvect, Color.White, 5);
            tempvect.X = 10.0f;
            tempvect.Y = 690.0f;
            Graphics.DrawText(String.Format("Attackers remaining: {0} / {1}",Battle.InitialAttackers-Battle.DestroyedAttackers, Battle.InitialAttackers), tempvect, Gamedata.Players[Battle.AttackerIndex].Playercolor, 5);
            tempvect.X = 10.0f;
            tempvect.Y = 730.0f;
            Graphics.DrawText(String.Format("Defenders remaining: {0} / {1}", Battle.InitialDefenders-Battle.DestroyedDefenders, Battle.InitialDefenders), tempvect, Gamedata.Players[Battle.DefenderIndex].Playercolor, 5);
            tempvect.X = 10.0f;
            tempvect.Y = 770.0f;
            if (Battle.BattleOver() && (((Gamedata.HumanPlayer== Battle.AttackerIndex) && (0==Battle.Defenders.Count)) || ((Gamedata.HumanPlayer==Battle.DefenderIndex) && (0==Battle.Defenders.Count))))
            {
                Graphics.DrawText("You won", tempvect, Color.Green, 5);
            }
            else
            {
                Graphics.DrawText("You Lost", tempvect, Color.Red, 5);
            }
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Draw();
            }
        }
        override public void Update()
        {// aktualisiert zustände und berechnet zb physik + effekte
            BattleMan.Update();
            if(Battle.BattleOver())
                ((Button)(Controls[5])).Active = true;
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Update();
            }
        }
        public void Init(BattleAI battle)
        {// initialisiert das kampffenster mit den übergebenen einheiten usw
            for (int i = 0; i < BattleMan.Battlefield.Count; i++)
            {
                BattleMan.Battlefield[i].Unit = null;
            }
            Battle = battle;
            if (Battle.AttackerIndex == Gamedata.HumanPlayer)
                SituationString = String.Format("Your Troops Attack Sector x{0} y{1}",Battle.BattleSector.X, Battle.BattleSector.Y);
            else
                SituationString = String.Format("Your Troops Defend Sector x{0} y{1}", Battle.BattleSector.X, Battle.BattleSector.Y);
        }
        public void NextTurnFunc()
        {
/*            if (Battle.BattleOver())
            {// prüfen ob kampf zu ende
                if((Battle.DefenderIndex == Battle.Gamedat.HumanPlayer) && ())
                    ((Button)(Controls[4])).Text = "You Won";
            }*/
            //am ende vom kampf auch beim battlemanager die einheiten aus sectoliste wieder entfernen und wenn sie im kampf sterben auch beim spieler entfernen,
            // und wenn letzter sector des feindes erobert anzeigen dass besiegt,
            Views.SwitchView(1);
        }
        public void Attackfunc()
        {
            BattleMan.Attackmode = true;
        }
        public void Movefunc()
        {
            BattleMan.Movemode = true;
        }
        public void Skipfunc()
        {
        }
        public void GiveUpfunc()
        {
        }
        public void AutofightFunc()
        {
            Battle.Autofight();
        }
    }
}
