﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using System.Reflection;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    public class GameData
    {
        public SectorManager Sectors;
        public int Turn, HumanPlayer,MaxBuildingLevel;
        public List<Player> Players;
        public bool GameRunning;

        public GameData()
        {// constructor
            Players = new List<Player>();
            Players.Add(new Player("Red",Color.Red));
            Players.Add(new Player("Green", Color.Green));
            Players.Add(new Player("Blue", Color.Blue));
            Players.Add(new Player("Yellow", Color.Yellow));
            Players.Add(new Player("Magenta", Color.Magenta));
            Players.Add(new Player("Cyan", Color.Cyan));
            Players.Add(new Player("Brown", Color.Brown));
            Players.Add(new Player("Wheat", Color.Wheat));
            Players.Add(new Player("None", Color.White));
            MaxBuildingLevel = 5;
            GameRunning = false;
            Clear();
        }

        public void SaveGame(String filename)
        {// speichert das spiel in eine datei
            try
            {
                FileStream fileStream = new FileStream(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location) + filename, FileMode.Create);
                BinaryFormatter binFormatter = new BinaryFormatter();
                Sectors.Serialize(binFormatter, fileStream);
                binFormatter.Serialize(fileStream, Players);
                binFormatter.Serialize(fileStream, Turn);
                binFormatter.Serialize(fileStream, HumanPlayer);
                binFormatter.Serialize(fileStream, MaxBuildingLevel);
                fileStream.Close();
            }
            catch (SerializationException e)
            {// die Datei kann nicht deserialisiert werden
                System.Windows.Forms.MessageBox.Show(e.Message);
            }
            catch (IOException e)
            {// Beim Versuch, die Datei zu öffnen, ist ein Fehler aufgetreten
                System.Windows.Forms.MessageBox.Show(e.Message);
            }
        }
        public void LoadGame(String filename)
        {// lädt das spiel aus einer datei
            try
            {
                FileStream fileStream = new FileStream(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location) + filename, FileMode.Open);
                BinaryFormatter binFormatter = new BinaryFormatter();
                Sectors.Deserialize(binFormatter, fileStream);
                Players = (List<Player>)binFormatter.Deserialize(fileStream);
                Turn = (int)binFormatter.Deserialize(fileStream);
                HumanPlayer = (int)binFormatter.Deserialize(fileStream);
                MaxBuildingLevel = (int)binFormatter.Deserialize(fileStream);
                fileStream.Close();
            }
            catch (SerializationException e)
            {// die Datei kann nicht deserialisiert werden
                System.Windows.Forms.MessageBox.Show(e.Message);
            }
            catch (IOException e)
            {// Beim Versuch, die Datei zu öffnen, ist ein Fehler aufgetreten
                System.Windows.Forms.MessageBox.Show(e.Message);
            } 
        }
        public void Update()
        {
        }
        public void NextTurn()
        {// berechnet nächsten zug usw (kämpfe, ki usw)
            bool allthere;
            ++Turn;
            int i,j,k,l, mindist, dist, startindex, minindex = 0, minunits, tmp, cnt;
            if (Turn < 30)
                minunits = 2;
            else if (Turn < 90)
                minunits = 4;
            else if (Turn < 150)
                minunits = 6;
            else
                minunits = 8;
            Random rand = new Random();
            Sectors.Turn();
            for (i = 0; i < Players.Count-1; i++)
            {// berechnen wie viel resourcen ab nächste runde zur verfügung stehen
                Players[i].AddTurnGain();
                if ((i != HumanPlayer) && (Players[i].SectorCount > 0))
                {// ein npc-spieler also ki machen wenn er noch sektoren hat
                    mindist = dist = 100000;
                    for (j = 0; j < Sectors.SectorList.Count; j++)
                    {// den attack sektor bestimmen als den der vor dem nächsten feindsektor liegt
                        if (Sectors.SectorList[j].Owner == i)
                        {// ein sektor dieses spielers also alle feindsektoren dazu finden
                            for (k = 0; k < Sectors.SectorList.Count; k++)
                            {
                                if ((Sectors.SectorList[k].Owner != i) && (Sectors.SectorList[k].Owner != 8))
                                {// der sektor gehört einem feind also abstand bestimmen
                                    dist = Sectors.GetSectorDistance(Sectors.SectorList[k], Sectors.SectorList[j]);
                                    if (dist < mindist)
                                    {
                                        mindist = dist;
                                        minindex = k;
                                        startindex = j;
                                    }
                                }
                            }
                        }
                    }
                    for (j = 0; j < Sectors.SectorList.Count; j++)
                    {// jetzt einen unbewohnten sektor finden der zwischen feind und player liegt
                        dist = Sectors.GetSectorDistance(Sectors.SectorList[minindex], Sectors.SectorList[j]);
                        if ((dist < 2) && (8 == Sectors.SectorList[j].Owner))
                        {// der sektor ist unbewohnt und liegt zwischen beiden gebieten
                            Players[i].CollectSector = j;
                            Players[i].AttackSector = minindex;
                            break;
                        }
                    }
                    for (j = 0; j < Sectors.SectorList.Count; j++)
                    {// alle sektoren durchgehen
                        if (i == Sectors.SectorList[j].Owner)
                        {// sektor gehört dem ki-spieler also gebäude und einheiten bauen
                            if ((-1 == Sectors.SectorList[j].BuildBuilding) && (false == Sectors.SectorList[j].BuildNoMore))
                            {// es wird kein gebäude gebaut also eines auswählen
                                cnt = 0;
                                do
                                {
                                    k = rand.Next(8);
                                    ++cnt;
                                } while ((Sectors.SectorList[j].Buildings[k].Level == 5) && (cnt < 100));
                                if (cnt > 99)
                                    Sectors.SectorList[j].BuildNoMore = true;
                                else
                                    Sectors.SectorList[j].BuildBuilding = k;
                            }
                            if ((-1 == Sectors.SectorList[j].BuildUnitID) && (Sectors.SectorList[j].Units.Count < Sectors.SectorList[j].Buildings[4].Level + 4))
                            {// es wird keine Einheit gebaut also eine bauen wenn noch platz ist und nicht der menschliche spieler
                                if (Turn < 12)
                                {// am anfang des spiels nur prospektor und basemodule bauen
                                    if (0 == Players[i].UnitCount)
                                    {// als erste einheit einen prospektor bauen
                                        Sectors.SectorList[j].BuildUnitID = 3;
                                        //# hier noch die kosten abziehen
                                    }
                                    else
                                    {// ansonsten ein basemodul
                                        Sectors.SectorList[j].BuildUnitID = 4;
                                        //# hier noch die kosten abziehen
                                    }
                                }
                                else
                                {// später dann einheit zufällig bestimmen
                                    Sectors.SectorList[j].BuildUnitID = rand.Next(Players[i].Units.Technologies.Count);
                                }
                            }
                        }
                        if (Sectors.SectorList[j].GetUnitCount(i) > 0)
                        {// einheiten in dem sektor gehören dem ki-spieler
                            if (j == Players[i].CollectSector)
                            {// in dem sektor werden die einheiten zum angriff gesammelt also warten bis alle da und dann angriff auf nachbarsektor
                                allthere = true;
                                for (k = 0; k < Sectors.SectorList[j].Units.Count; k++)
                                {
                                    if (Sectors.SectorList[j].Units[k].ETA > 0)
                                    {
                                        allthere = false;
                                        break;
                                    }
                                }
                                if (allthere)
                                {// alle einheiten die zugewiesen wurden sind vorhanden
                                    for (k = 0; k < Sectors.SectorList[j].Units.Count; k++)
                                    {// alle einheiten durchgehen
                                        if(Sectors.SectorList[Players[i].AttackSector].GetUnitCount(i) <= Sectors.SectorList[Players[i].AttackSector].Buildings[4].Level + 4)
                                        {// es ist noch platz im zielsektor also einheiten angreifen lassen, jeder spieler kann so viele einheiten hinschicken wie platz haben da am ende nur einheiten eines spielers übrig bleiben
                                            Sectors.SectorList[Players[i].AttackSector].Units.Add(Sectors.SectorList[j].Units[k]);
                                            Sectors.SectorList[j].Units.RemoveAt(k);
                                        }
                                    }
                                }
                            }
                            else
                            {// ein normaler sektor
                                for (k = 0; k < Sectors.SectorList[j].Units.Count; k++)
                                {// alle einheiten durchgehen
                                    if ((0 == Sectors.SectorList[j].Units[k].Type) && (0 == Sectors.SectorList[j].Units[k].ETA))
                                    {// ein prospektor also unerforschte sektoren suchen
                                        Sectors.SectorList[j].Examined[i] = true;   // sobald der prospector da ist ist der sektor erforscht
                                        dist = mindist = 10000;
                                        for (l = 0; l < Sectors.SectorList.Count; l++)
                                        {
                                            dist = Sectors.GetSectorDistance(Sectors.SectorList[l], Sectors.SectorList[j]);
                                            if ((dist < mindist) && (Sectors.SectorList[l].Units.Count < Sectors.SectorList[l].Buildings[4].Level + 4) && false == Sectors.SectorList[l].Examined[i])
                                            {// den sektor mit kleinstem abstand wo platz ist suchen der unerforscht ist (und in reichweite des gebietes)
                                                mindist = dist;
                                                minindex = l;
                                            }
                                        }
                                        Sectors.SectorList[j].Units[k].ETA = (int)Math.Ceiling((float)mindist / Sectors.SectorList[j].Units[k].Speed);
                                        Sectors.SectorList[minindex].Units.Add(Sectors.SectorList[j].Units[k]);
                                        Sectors.SectorList[j].Units.RemoveAt(k);
                                    }
                                    else if ((1 == Sectors.SectorList[j].Units[k].Type) && (0 == Sectors.SectorList[j].Units[k].ETA))
                                    {// ein basemodul also unbesiedelten sektor suchen
                                        if (8 == Sectors.SectorList[j].Owner)
                                        {// der aktuelle sektor ist unbesiedelt also besiedeln
                                            Sectors.SectorList[j].Owner = i;
                                            Sectors.SectorList[j].Units.RemoveAt(k);
                                        }
                                        else
                                        {// das basemodul muss sich erst in unbesiedelten sektor bewegen
                                            dist = mindist = 10000;
                                            for (l = 0; l < Sectors.SectorList.Count; l++)
                                            {
                                                dist = Sectors.GetSectorDistance(Sectors.SectorList[l], Sectors.SectorList[j]);
                                                if ((dist < mindist) && (Sectors.SectorList[l].Units.Count < Sectors.SectorList[l].Buildings[4].Level + 4) && (8 == Sectors.SectorList[l].Owner) && (dist <= Sectors.SectorList[j].Units[k].PlanetMoveRange))
                                                {// den sektor mit kleinstem abstand wo platz ist suchen der unerforscht ist (und in reichweite des gebietes)
                                                    mindist = dist;
                                                    minindex = l;
                                                }
                                            }
                                            Sectors.SectorList[j].Units[k].ETA = (int)Math.Ceiling((float)mindist / Sectors.SectorList[j].Units[k].Speed);
                                            Sectors.SectorList[minindex].Units.Add(Sectors.SectorList[j].Units[k]);
                                            Sectors.SectorList[j].Units.RemoveAt(k);
                                        }
                                    }
                                    else if(0 < Sectors.SectorList[j].Units[k].Speed)
                                    {// eine andere einheit also entweder zur verteidigung dalassen (minunits) oder zum CollectSector bewegen
                                        if ((i == Sectors.SectorList[j].Owner) && (Sectors.SectorList[j].GetUnitCount(i) > minunits))
                                        {// ein eigener sektor also minunits zur verteidigung dalassen rest bewegen, dabei auch die einheiten "von unten" wegnehmen damit die nicht-bewegbaren nachrutschen
                                            if (Sectors.SectorList[Players[i].CollectSector].Units.Count < Sectors.SectorList[Players[i].CollectSector].Buildings[4].Level + 4)
                                            {// im zielsektor ist noch platz also da hinschicken
                                                Sectors.SectorList[j].Units[k].ETA = (int)Math.Ceiling((float)Sectors.GetSectorDistance(Sectors.SectorList[Players[i].CollectSector], Sectors.SectorList[j]) / Sectors.SectorList[j].Units[k].Speed);
                                                Sectors.SectorList[Players[i].CollectSector].Units.Add(Sectors.SectorList[j].Units[k]);
                                                Sectors.SectorList[j].Units.RemoveAt(k);
                                            }
                                            else
                                            {// was anderes mit der einheit machen
                                                bool enemyneighbour = false;
                                                int enemysector = 0;
                                                for(l = 0; l < Sectors.SectorList.Count; l++)
                                                {
                                                    if((Sectors.SectorList[l].Owner < 8) && (Sectors.SectorList[l].Owner != i) && (1 == (int)Math.Ceiling((float)Sectors.GetSectorDistance(Sectors.SectorList[l], Sectors.SectorList[j]))))
                                                    {// ein benachbarter feindsektor wurde gefunden also einheiten dahin senden
                                                        enemyneighbour = true;
                                                        enemysector = l;
                                                        break;  // aufhören da der erste sctor angegriffen wird
                                                    }
                                                }
                                                if(enemyneighbour)
                                                {// ein nachbarsektor ist von feinden besetzt also den angreifen
                                                    for (k = 0; k < Sectors.SectorList[j].Units.Count; k++)
                                                    {// alle einheiten durchgehen
                                                        if ((Sectors.SectorList[enemysector].GetUnitCount(i) <= Sectors.SectorList[enemysector].Buildings[4].Level + 4) && (0 != Sectors.SectorList[j].Units[k].Type) && (1 != Sectors.SectorList[j].Units[k].Type) && (7 != Sectors.SectorList[j].Units[k].Type))
                                                        {// es ist noch platz im zielsektor also einheiten angreifen lassen, jeder spieler kann so viele einheiten hinschicken wie platz haben da am ende nur einheiten eines spielers übrig bleiben
                                                            Sectors.SectorList[enemysector].Units.Add(Sectors.SectorList[j].Units[k]);
                                                            Sectors.SectorList[j].Units.RemoveAt(k);
                                                        }
                                                    }
                                                }
                                                else
                                                {// einheit in einen zufälligen sektor im umkreis von 3 einheiten schicken wo platz ist und der dem player oder niemandem gehört
                                                    l = 0;
                                                    while (l++ < 100)
                                                    {// hundert versuche einen passenden sector zu finden, danach bleibt die einheit wo sie ist
                                                        tmp = rand.Next(Sectors.SectorList.Count-1);
                                                        if (4 > (int)Math.Ceiling((float)Sectors.GetSectorDistance(Sectors.SectorList[tmp], Sectors.SectorList[j])) && (Sectors.SectorList[tmp].Units.Count < Sectors.SectorList[tmp].Buildings[4].Level + 4))
                                                        {
                                                            Sectors.SectorList[j].Units[k].ETA = (int)Math.Ceiling((float)Sectors.GetSectorDistance(Sectors.SectorList[tmp], Sectors.SectorList[j]) / Sectors.SectorList[j].Units[k].Speed);
                                                            Sectors.SectorList[tmp].Units.Add(Sectors.SectorList[j].Units[k]);
                                                            Sectors.SectorList[j].Units.RemoveAt(k);
                                                            break;  // while verlassen da ziel gefunden
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            CalcTurnGain();// berechnen wie viel resourcen ab nächste runde zur verfügung stehen
        }
        public void CalcTurnGain()
        {// berechnet wie viele resourcen fp usw pro runde dazu kommen
            int i,j, owner;
            for (i = 0; i < Players.Count; i++)
            {// die zähler aller spieler zurücksetzen
                Players[i].RoundMins = Players[i].RoundEnergy = Players[i].RoundLifeSupport = Players[i].RoundTechPoints = Players[i].SectorCount = Players[i].UnitCount = 0;
            }
            for (i = 0; i < Sectors.SectorList.Count; i++)
            {
                owner = Sectors.SectorList[i].Owner;
                if (owner != 8)
                {// sektor gehört einem spieler also zählen
                    Players[owner].RoundMins += Sectors.SectorList[i].Buildings[0].Level * Sectors.SectorList[i].Ore;    // für die resourcen wird der basiswert des sectors mal den level der harvestingeinrichtung pro runde dazugewonnen
                    Players[owner].RoundLifeSupport += Sectors.SectorList[i].Buildings[1].Level * Sectors.SectorList[i].Anorganics;
                    Players[owner].RoundEnergy += Sectors.SectorList[i].Buildings[2].Level * Sectors.SectorList[i].Energy;
                    Players[owner].RoundTechPoints += Sectors.SectorList[i].Buildings[5].Level;   // jede stufe der forschungsanstalt erzeugt einen techpunkt pro runde
                    ++Players[owner].SectorCount;
                    for (j = 0; j < Sectors.SectorList[i].Units.Count; j++ )
                    {// die einheiten zählen
                        if (Sectors.SectorList[i].Units[j].Owner == owner)
                            ++Players[owner].UnitCount;
                    }
                }
            }
        }
        public void Clear()
        {// setzt das spiel zurück zum neu starten
            Turn = 1;
            for (int i = 0; i < Players.Count; i++)
            {
                Players[i].Clear();
            }
        }
    }
}
