﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace PlanetaryDomination
{
    public class MenuView : BaseView
    {// zeigt das hauptmenü an

        public MenuView(GraphicsManager graphicsman, InputManager inputman, SoundManager soundman, ViewManager viewman, GameData gamedat)
            : base(graphicsman, inputman, soundman, viewman, gamedat)
        {// konstruktor
            Controls.Add(new Button(500, 200, 280, 30, "New Game", Color.Azure, 4, Graphics, Input, Sound));   // #0
            ((Button)(Controls[0])).ButtFunc = Newfunc;
            Controls.Add(new Button(500, 300, 280, 30, "Load Quicksave", Color.Azure, 4, Graphics, Input, Sound));    // #1
            ((Button)(Controls[1])).ButtFunc = Quickfunc;
            Controls.Add(new Button(500, 400, 280, 30, "Load Autosave", Color.Azure, 4, Graphics, Input, Sound)); // #2
            ((Button)(Controls[2])).ButtFunc = Autofunc;
            Controls.Add(new Button(500, 500, 280, 30, "Credits", Color.Azure, 4, Graphics, Input, Sound));   // #3
            ((Button)(Controls[3])).ButtFunc = Credfunc;
            Controls.Add(new Button(500, 600, 280, 30, "Quit Game [q]", Color.Azure, 4, Graphics, Input, Sound));  // #4 die funktion wird in game auf exit gesetzt!
//            ((Button)(Controls[4])).Shortkey = Keys.Escape;   //# geht nicht da es neben dem wechsel zum hauptmenü nochmal aufgerufen wird und spiel beendet
            ((Button)(Controls[4])).Shortkey = Keys.Q;
            Controls.Add(new Button(500, 100, 280, 30, "Resume Game", Color.Azure, 4, Graphics, Input, Sound));   // #5
            ((Button)(Controls[5])).ButtFunc = ResumeFunc;
            ((Button)(Controls[5])).Active = false;
        }
        override public void Draw()
        {// rendert alles
            tempvect.X = 450.0f;// hier selber die gui malen
            tempvect.Y = 50.0f;
            Graphics.DrawText("Planetary Domination Main Menu", tempvect, Color.White, 5);
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Draw();
            }
        }
        override public void Update()
        {// aktualisiert zustände und berechnet zb physik + effekte
            if (((MapView)(Views.Views[1])).Gamedata.GameRunning)
                Controls[5].Active = true;  // den resume button nur anzeigen wenn spiel schon läuft
            else
                Controls[5].Active = false;
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Update();
            }
        }
        private void Newfunc()
        {//ausführen für button new game
            Views.SwitchView(2);    // spiel erstellen dialog
        }
        private void Quickfunc()
        {//ausführen für button load quicksave
            try
            {
                Views.Gamedata.LoadGame("\\Quicksave.sav");
                ((MapView)(Views.Views[1])).Sectors.CalcViewParams();
                Gamedata.GameRunning = true;
                Views.SwitchView(1);    // sektoransicht
            }
            catch(Exception e)
            {
                Sound.PlaySound(5);
                String temp = e.Message;
            }
        }
        private void Autofunc()
        {//ausführen für button load autosave
            try
            {
                Views.Gamedata.LoadGame("\\Autosave.sav");
                ((MapView)(Views.Views[1])).Sectors.CalcViewParams();
                Gamedata.GameRunning = true;
                Views.SwitchView(1);    // sektoransicht
            }
            catch(Exception e)
            {
                Sound.PlaySound(5);
                String temp = e.Message;
            }
        }
        private void Credfunc()
        {//ausführen für button credits
            Views.SwitchView(3);    // credits dialog
        }
        private void ResumeFunc()
        {// setzt das spiel an der stelle fort
            Views.SwitchView(1);    // zu kartenansicht zurückkehren
        }
    }
}
