﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

namespace PlanetaryDomination
{
    public class ResearchView : BaseView
    {
        private int ActUnit;
        List<Unit> UnitstoShow;
        List<String> Types;

        public ResearchView(GraphicsManager graphicsman, InputManager inputman, SoundManager soundman, ViewManager viewman, GameData gamedat)
            : base(graphicsman, inputman, soundman, viewman, gamedat)
        {// konstruktor
            Controls.Add(new Button(1055, 920, 220, 30, "Return", Color.Azure, 4, Graphics, Input, Sound));   // #0
            ((Button)(Controls[0])).ButtFunc = Returnfunc;
            Controls.Add(new Button(200, 100, 220, 30, "<-", Color.Azure, 4, Graphics, Input, Sound));   // #1
            ((Button)(Controls[1])).ButtFunc = Prevfunc;
            Controls.Add(new Button(860, 100, 220, 30, "->", Color.Azure, 4, Graphics, Input, Sound));   // #2
            ((Button)(Controls[2])).ButtFunc = Nextfunc;
            Types = new List<String>();
            Types.Add("0-Prospector");
            Types.Add("1-Basemodule");
            Types.Add("2-Infantery");
            Types.Add("3-Vehicle");
            Types.Add("4-ArmedVehicle");
            Types.Add("5-Tank");
            Types.Add("6-Artillery");
            Types.Add("7-Building");
        }
        override public void Draw()
        {// rendert alles
            tempvect.X = 510.0f;// hier selber die gui malen
            tempvect.Y = 50.0f;
            Graphics.DrawText("Detailed View on your Units", tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 100.0f;
            Graphics.DrawText(String.Format("{0} / {1}", ActUnit+1, UnitstoShow.Count), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 140.0f;
            Graphics.DrawText(String.Format("{0}", UnitstoShow[ActUnit].Name), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 180.0f;
            Graphics.DrawText(String.Format("Type: {0}", Types[UnitstoShow[ActUnit].Type]), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 220.0f;
            Graphics.DrawText(String.Format("Attack: {0}", UnitstoShow[ActUnit].Attack), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 260.0f;
            Graphics.DrawText(String.Format("Defence: {0}", UnitstoShow[ActUnit].Defence), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 300.0f;
            Graphics.DrawText(String.Format("Damage: {0}", UnitstoShow[ActUnit].Damage), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 340.0f;
            Graphics.DrawText(String.Format("MinFireRange: {0}", UnitstoShow[ActUnit].MinFireRange), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 380.0f;
            Graphics.DrawText(String.Format("MaxFireRange: {0}", UnitstoShow[ActUnit].MaxFireRange), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 420.0f;
            Graphics.DrawText(String.Format("Experience: {0}", UnitstoShow[ActUnit].Experience), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 460.0f;
            Graphics.DrawText(String.Format("BattleMoveRange: {0}", UnitstoShow[ActUnit].BattleMoveRange), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 500.0f;
            Graphics.DrawText(String.Format("Hitpoints: {0}", UnitstoShow[ActUnit].Hitpoints), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 540.0f;
            Graphics.DrawText(String.Format("MaxHitpoints: {0}", UnitstoShow[ActUnit].Maxhitpoints), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 580.0f;
            Graphics.DrawText(String.Format("Speed: {0}", UnitstoShow[ActUnit].Speed), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 620.0f;
            Graphics.DrawText(String.Format("PlanetMoveRange: {0}", UnitstoShow[ActUnit].PlanetMoveRange), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 660.0f;
            Graphics.DrawText(String.Format("ProductionCost: {0}", UnitstoShow[ActUnit].ProductionCost), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 700.0f;
            Graphics.DrawText(String.Format("MineralCost: {0}", UnitstoShow[ActUnit].MinCost), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 740.0f;
            Graphics.DrawText(String.Format("OrganicsCost: {0}", UnitstoShow[ActUnit].OrgCost), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 780.0f;
            Graphics.DrawText(String.Format("EnergyCost: {0}", UnitstoShow[ActUnit].EnergyCost), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 820.0f;
            Graphics.DrawText(String.Format("MinFactoryLevel: {0}", UnitstoShow[ActUnit].MinFactoryLevel), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 860.0f;
            Graphics.DrawText(String.Format("MinTechLevel: {0}", UnitstoShow[ActUnit].MinTechLevel), tempvect, Color.White, 5);
            tempvect.X = 500.0f;
            tempvect.Y = 900.0f;
            Graphics.DrawText(String.Format("ETA: {0}", UnitstoShow[ActUnit].ETA), tempvect, Color.White, 5);
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Draw();
            }
        }
        override public void Update()
        {// aktualisiert zustände und berechnet zb physik + effekte
            for (int i = 0; i < Controls.Count; i++)
            {
                Controls[i].Update();
            }
        }
        private void Returnfunc()
        {//wechselt in die kartenansicht zurück
            Views.SwitchView(1);    // zu kartenansicht zurückkehren
        }
        private void Nextfunc()
        {// zeigt die nächste einheit an
            if (ActUnit < UnitstoShow.Count-1)
            {// weiterschalten
                ++ActUnit;
            }
            else
            {
                Sound.PlaySound(5);
            }
        }
        private void Prevfunc()
        {// zeigt die vorhergehende einheit an
            if (ActUnit > 0)
            {// zurückschalten
                --ActUnit;
            }
            else
            {
                Sound.PlaySound(5);
            }
        }
        public void SetShowStates(List<Unit> techs, int pos)
        {// setzt das array auf die einheiten die angezeigt werden sollen und evtl die position
            UnitstoShow = techs;
            ActUnit = pos;
        }
    }
}
