﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PlanetaryDomination
{
    [Serializable()]
    public class Unit
    {
        public int MinFactoryLevel, MinTechLevel, TextureID, Type, ProductionCost, MinCost, OrgCost, EnergyCost,MinFireRange,MaxFireRange,BattleMoveRange,PlanetMoveRange, ETA, Techlistindex, Owner; // stufe auf der Fabrik sein muss um die Einheit zu bauen
        public float Experience, Attack, Defence, Hitpoints, Maxhitpoints, Speed, Damage;
        public String Name;
        public bool TurnMoved;
        public int Battlesec;

        // type wird im editor direkt aus combobox ausgelesen: 0-Prospector,1-Basemodule,2-Infantery,3-Vehicle,4-ArmedVehicle,5-Tank,6-Artillery,7-Building
        public Unit()
        {
            Experience = 1.0f;
            ETA = 0;    // einheit ist da wo gebaut, wenn bewegt wird wird dauer ausgerechnet (eta) und jede runde um 1 reduziert, sobald 0 ist einheit angekommen
            Owner = 8;
            TurnMoved = false;
        }
        public Unit(Unit copyfrom)
        {// erzeugt kopie aus anderer einheit (aus techtree)
            Experience = copyfrom.Experience;  // hier alle eigenschaften kopieren
            Name = copyfrom.Name;
            MinFactoryLevel = copyfrom.MinFactoryLevel;
            MinTechLevel = copyfrom.MinTechLevel;
            TextureID = copyfrom.TextureID;
            Type = copyfrom.Type;
            ProductionCost = copyfrom.ProductionCost;
            MinCost = copyfrom.MinCost;
            OrgCost = copyfrom.OrgCost;
            EnergyCost = copyfrom.EnergyCost;
            MinFireRange = copyfrom.MinFireRange;
            MaxFireRange = copyfrom.MaxFireRange;
            BattleMoveRange = copyfrom.BattleMoveRange;
            PlanetMoveRange = copyfrom.PlanetMoveRange;
            Damage = copyfrom.Damage;
            Attack = copyfrom.Attack;
            Defence = copyfrom.Defence;
            Hitpoints = copyfrom.Maxhitpoints;  // mit vollen hp starten
            Maxhitpoints = copyfrom.Maxhitpoints;
            Speed = copyfrom.Speed;
            ETA = copyfrom.ETA;
        }
        public void AttackUnit(Unit target, int distance)
        {// greift die target-einheit an
            float damage = 0.0f;
            if ((distance >= MinFireRange) && (distance <= MaxFireRange))
            {// ziel ist in reichweite also trefferchance + schaden prüfen und sehen ob die einheit dadurch ausgeschaltet werden könnte
                damage = ((Attack * Experience) / (target.Defence * target.Experience)) * Damage;
                target.Hitpoints -= damage;
            }
        }
    }
}
